from django.conf.urls import url
from . import views

urlpatterns = [
url(r'^person/list/$', views.PersonListView.as_view(), name='person_list'),
url(r'^person/create/$', views.person_create, name='person_create'),
url(r'^person/edit/(?P<pk>[0-9]+)$', views.person_edit, name='person_edit'),
url(r'^person/delete/(?P<pk>[0-9]+)$', views.PersonDelete.as_view(), name='person_delete'),
url(r'^place/list/$', views.PlaceListView.as_view(), name='place_list'),
url(r'^place/create/$', views.place_create, name='place_create'),
url(r'^place/edit/(?P<pk>[0-9]+)$', views.place_edit, name='place_edit'),
url(r'^place/delete/(?P<pk>[0-9]+)$', views.PlaceDelete.as_view(), name='place_delete'),
url(r'^place/geojson/$', views.getGeoJson, name='getGeoJson'),
url(r'^place/geojson/list/$', views.getGeoJsonList, name='getGeoJsonList'),
url(r'^place/network/list/$', views.getNetJsonList, name='getNetJsonList'),
url(r'^institution/network/list/$', views.getNetJsonListInstitution, name='getNetJsonListInstitution'),
url(r'^institution/list/$', views.InstitutionListView.as_view(), name='institution_list'),
url(r'^institution/list/(?P<collection_id>[0-9]+)$', views.institution_custom_list, name='institution_list_custom'),
url(r'^institution/create/$', views.institution_create, name='institution_create'),
url(r'^institution/edit/(?P<pk>[0-9]+)$', views.institution_edit, name='institution_edit'),
url(r'^institution/delete/(?P<pk>[0-9]+)$', views.InstitutionDelete.as_view(), name='institution_delete'),
url(r'^event/list/$', views.EventListView.as_view(), name='event_list'),
url(r'^event/create/$', views.event_create, name='event_create'),
url(r'^event/edit/(?P<pk>[0-9]+)$', views.event_edit, name='event_edit'),
url(r'^event/delete/(?P<pk>[0-9]+)$', views.EventDelete.as_view(), name='event_delete'),
url(r'^work/list/$', views.WorkListView.as_view(), name='work_list'),
url(r'^work/create/$', views.work_create, name='work_create'),
url(r'^work/edit/(?P<pk>[0-9]+)$', views.work_edit, name='work_edit'),
url(r'^work/delete/(?P<pk>[0-9]+)$', views.WorkDelete.as_view(), name='work_delete'),
url(r'^resolve/place/(?P<pk>[0-9]+)/(?P<uri>.+)$', views.resolve_ambigue_place, name='resolve_ambigue_place'),
url(r'^maps/birthdeath/$', views.birth_death_map, name='birth_death_map'),
url(r'^networks/relation_place/$', views.pers_place_netw, name='pers_place_netw'),
url(r'^networks/relation_institution/$', views.pers_inst_netw, name='pers_inst_netw'),
url(r'^networks/generic/$', views.generic_network_viz, name='generic_network_viz'),
]
